#!/usr/bin/python
# -*- coding: utf-8 -*-
import subprocess
import sys, os
PGSQL_CMD = "/usr/bin/psql"

def get_translated_mb_size(size, unit):
    if 'GB' == unit:
        return float(size) * 1024
    elif 'MB' == unit:
        return float(size)
    elif 'kB' == unit:
        return float(size) / 1024

def get_ips_db_size():
    # db_name | db_size
    #---------+---------
    # synotps | 6618 kB
    # (1 row)

    strSelect = "SELECT t1.datname AS db_name, pg_size_pretty(pg_database_size(t1.datname)) AS db_size "
    strFrom = "FROM pg_database t1 "
    strWhere = "WHERE t1.datname = 'synotps' "
    strOrderBy = "ORDER BY pg_database_size(t1.datname) DESC"
    psql_cmd = strSelect + strFrom + strWhere + strOrderBy + ";"
    out = subprocess.check_output([PGSQL_CMD, \
            "-U", "postgres", "-c", psql_cmd])
    rawSize = out.splitlines()[2].strip().split(' ')[2]
    unit = out.splitlines()[2].strip().split(' ')[3]

    return get_translated_mb_size(rawSize, unit)
