#!/usr/bin/python
# -*- coding: utf-8 -*-
import subprocess
import sys, os
import time
from synoips_utils import *

START_CMD = "/sbin/start"
STOP_CMD = "/sbin/stop"
STATUS_CMD = "/sbin/status"
SURICATA = "synosuricata"
PGSQL_CMD = "/usr/bin/psql"
IONICE_CMD = "/var/packages/ThreatPrevention/target/bin/ionice"
DB_TABLE_LIST = ['data', 'event', 'icmphdr', 'iphdr', 'tcphdr', 'udphdr'];
PACKAGE_USR_CONF_DIR = "/var/packages/ThreatPrevention/etc/"
USER_SETTING_CONF = PACKAGE_USR_CONF_DIR + "/" + "db_size.conf"
SYNO_GET_KEY_VALUE = "/usr/syno/bin/synogetkeyvalue"

os.nice(19)
subprocess.call([IONICE_CMD, '-c3', '-p', str(os.getpid())])

def get_event_count():
    # count
    # -----
    #   1
    #  (1 row)
    out = subprocess.check_output([PGSQL_CMD, \
            "-U", "postgres", "synotps", "-c", "SELECT count(*) FROM event;"])
    return int(out.splitlines()[2].strip())


def get_cid_max():
    # cid
    # -----
    #   1
    #  (1 row)
    out = subprocess.check_output([PGSQL_CMD, \
            "-U", "postgres", "synotps", "-c", "SELECT MAX(cid) FROM event;"])
    return int(out.splitlines()[2].strip())

def get_cid_min():
    out = subprocess.check_output([PGSQL_CMD, \
            "-U", "postgres", "synotps", "-c", "SELECT MIN(cid) FROM event;"])
    return int(out.splitlines()[2].strip())

def remove_events(num_event):
#    print "remove", num_event, "events"

    new_cid_min = get_cid_min() + num_event

    for table in DB_TABLE_LIST:
        psql_cmd = "DELETE FROM " + table + " WHERE cid<" + str(new_cid_min) + ";"
        out = subprocess.check_output([PGSQL_CMD, \
             "-U", "postgres", "synotps", "-c", psql_cmd])
    return

def get_user_setting_db_size():
    out = subprocess.check_output([SYNO_GET_KEY_VALUE, USER_SETTING_CONF, "db_size"])

    return 500 if not out else int(out)

def exec_vacuum_full():
    psql_cmd = "VACUUM FULL;"
    out = subprocess.check_output([PGSQL_CMD, \
            "-U", "postgres", "synotps", "-c", psql_cmd])
    return

def is_sensor_enabled():
    out = subprocess.check_output([STATUS_CMD, SURICATA])
    status = out.split(' ')[1]

    if 'start/running' == status:
        return True
    else:
        return False

event_count = get_event_count()
#print"current event count:", event_count
#print "cid_max:", get_cid_max()
#print "cid_min:", get_cid_min()
user_db_size = get_user_setting_db_size()
ips_db_size = get_ips_db_size()

while ips_db_size > user_db_size:
    event_count = get_event_count()
    if (1000 >= event_count):
        break
    remove_events(event_count / 2)
    exec_vacuum_full()
    ips_db_size = get_ips_db_size()
    #print "#ips_db_size", ips_db_size
    #print "#event_count", event_count

sys.exit(0)
